do
	local _, playerClass = UnitClass("player")
	if playerClass ~= "WARLOCK" then return end
end

local MODULE_NAME = "Affliction"
local Faceroller = _G["Faceroller"]
local gsi = Faceroller.gsi

local haunt = 59164
local corr = 47813
local ua = 47843
local coa = 47864
local sb = 47809
local drainsoul = 47855

local LTGLYPH = 63320
local LTBUFF = 63321
local LT = 57946

local glyphed_lifetap
local lifetap_buff

local Init = function()
	
	local spells = {
		[sb] = 0,		-- shadow bolt
		[drainsoul] = 0,-- drain soul
		[haunt] = 0,    -- haunt
        
	}
	
	Faceroller:RegisterDebuff(corr, true)
	Faceroller:RegisterDebuff(coa, true)
    Faceroller:RegisterDebuff(haunt, true)
    Faceroller:RegisterDebuff(ua, true)
	
    glyphed_lifetap = Faceroller:HasGlyph(LTGLYPH)
    
	if glyphed_lifetap == true then
        Faceroller:RegisterBuff(LTBUFF)
		lifetap_buff = gsi[LTBUFF]
    end
	
	return spells
end

local NextShot = function(gcd, spells, buffs, debuffs, myDebuffs)

	local th = max (0.5, gcd)
	th = th + 0.1
	
	local lifetap = buffs[lifetap_buff]
	local my_corruption = myDebuffs[gsi[corr]]
	local my_coa = myDebuffs[gsi[coa]]
	local my_haunt = myDebuffs[gsi[haunt]]
	local my_ua = myDebuffs[gsi[ua]]
	local spell_haunt = spells[haunt]
	
	local filler = sb
	
	if(UnitHealth("target")/UnitHealthMax("target") < .25) then
		filler = drainsoul
	end
	
	local next_spell  = filler
	
	if(my_coa.active == false) then
		next_spell = coa
	end
	
	if(my_ua.active == false) then
		next_spell = ua
	end
	
	if(my_corruption.active == false) then
		next_spell = corr
	end
	
	if(my_haunt.active == false or spell_haunt.cd < th) then
		next_spell = haunt
	end
	
	if glyphed_lifetap == true then 
		if lifetap.active == false or lifetap.time_left < th then
			next_spell = LT
		end
	end
	
	if(UnitPower("player") < 700) then
		next_spell = LT
	end
	
	return next_spell
end

Faceroller:RegisterModule(MODULE_NAME, Init, NextShot, nil)
